#ifndef PARSER_CLIKE_MAX_CASES
 #define PARSER_CLIKE_MAX_CASES 12
#endif

template<typename DerivedT>
class CLst
{
public:
    typedef DerivedT embed_t;
    DerivedT& derived()
    {
        return *static_cast<DerivedT*>(this);
    }

    DerivedT const& derived() const
    {
        return *static_cast<DerivedT const*>(this);
    }
};

template<int val, class A>
class CLst_1: public CLst< CLst_1<val, A> >
{
public:
    typedef CLst_1<val,A> parent_t;
    //^incorrect, but will prevent a horde of ugly warnings
    // if the number of switchcases does not match
    
    static const int value = val;
    static const int depth = 1;
    const A ref;
public:
    CLst_1(const A& r)  : ref(r.derived())
    {
    }
    
    const Seq<TKn, A>
    makeparser() const
    {
        return Seq<TKn, A> (TKn(val), ref);
    }
};

template<unsigned N,class T>
class caseparser;

template<unsigned N,
         int val,class A,
         typename parent>
class CLst_2 : public parent
{
    typedef CLst_2<N,val,A,parent> this_t;
public:
    typedef parent parent_t;
    static const int value = val;
    static const int depth = N;
    const A ref;
public:
    CLst_2(const parser<A>& r, const parent& p) : parent(p), ref(r.derived())
    {
    }
    
    caseparser<N,this_t> makeparser() const
    {
        return caseparser<N,this_t> (*this);
    }
private:
};

template<typename C, int N2> struct getcasevalue
{
    static const int value = getcasevalue<typename C::parent_t,N2-1>::value;
};
template<>template<typename C> struct getcasevalue<C,0>
{
    static const int value = C::value;
};

template<typename C, int N2,typename ScannerT> struct caseparse
{
    bool operator() (const C&c, ScannerT& scan)const
        { return caseparse<typename C::parent_t,N2-1,ScannerT>()
                    ( (typename C::parent_t&)(c) , scan ); }
};
template<>template<typename C,typename ScannerT> struct caseparse<C,0,ScannerT>
{
    bool operator() (const C&c, ScannerT& scan)const
        { return c.ref.parse(scan); }
};


template<unsigned N,class T>
class caseparser;


#include <boost/preprocessor/repeat.hpp>
#include <boost/preprocessor/repeat_from_to.hpp>

#ifdef PARSER_DEBUG
template<typename T>
static void PARSER_CLIKE_REPORT_CASEMATCH(T tok)
{
    fprintf(stderr, "- Match, it was %s\n", GetTokenName((QBtoken)tok).c_str());
}
template<typename T>
static void PARSER_CLIKE_REPORT_CASENOMATCH(T got)
{
    fprintf(stderr, "- No match, it was %s\n", GetTokenName((QBtoken)got).c_str());
}
template<typename CharT>
static void PARSER_CLIKE_REPORT_CASELIST_OPTIONS(const std::basic_string<CharT>& opts)
{
    fprintf(stderr, "Is it %s?\n", opts.c_str());
}
#else
# define PARSER_CLIKE_REPORT_CASEMATCH(d)   
# define PARSER_CLIKE_REPORT_CASENOMATCH(d)
# define PARSER_CLIKE_REPORT_CASELIST_OPTIONS(opts)
#endif

#define PARSER_CLIKE_PARSE_CASES(z,N,_) \
    case getcasevalue<T,N>::value: \
        PARSER_CLIKE_REPORT_CASEMATCH((getcasevalue<T,N>::value)); \
        if(caseparse<T,N,ScannerT>() (caselist,scan)) return true; else break;

#define PARSER_CLIKE_REPORT_CASES(z,N,_) \
    PARSER_CLIKE_REPORT_CASEOPTION((getcasevalue<T,N>::value));
#define PARSER_CLIKE_CASE_WHATFUNC(z,N,max) \
    +ClikeCaseParserCaseAppend<max-N-1,QBtoken>()((QBtoken)getcasevalue<T,N>::value)

template<unsigned N,typename Toktype>
struct ClikeCaseParserCaseAppend
{
    inline const std::string operator() (Toktype d)
        { return GetTokenName(d) + ", "; }
};
template<>template<typename Toktype>
struct ClikeCaseParserCaseAppend<1,Toktype>
{
    inline const std::string operator() (Toktype d)
        { return GetTokenName(d) + " or "; }
};
template<>template<typename Toktype>
struct ClikeCaseParserCaseAppend<0,Toktype>
{
    inline const std::string operator() (Toktype d)
        { return GetTokenName(d); }
};

#define PARSER_CLIKE_PARSE_SWITCHES(z,N,_) \
  template<class T> \
  class caseparser<N,T>: \
    public parser<caseparser<N,T> > \
  { \
      typedef parser<caseparser<N,T> > base_t; \
      const T caselist; \
  public: \
      caseparser(const T& list) : base_t(), caselist(list) { } \
      \
      template<typename ScannerT> \
      bool parse(ScannerT& scan) const \
      { \
          if(scan.eof()) return false; \
          \
          typename ScannerT::iterator it = scan.pos(); \
          typename ScannerT::value_type got = scan.get(); \
          \
          PARSER_CLIKE_REPORT_CASELIST_OPTIONS(what()); \
          switch(got) \
          { \
              BOOST_PP_REPEAT_FROM_TO_##z(0, N, PARSER_CLIKE_PARSE_CASES, _) \
              default:  /* default to prevent floods of warnings */ \
                  PARSER_CLIKE_REPORT_CASENOMATCH(got); \
          } \
          scan.revert(it); \
          return false;\
      } \
      static const std::string what() \
      { \
          return ""BOOST_PP_REPEAT_FROM_TO_##z(0, N, PARSER_CLIKE_CASE_WHATFUNC, N); \
      } \
  };

BOOST_PP_REPEAT(PARSER_CLIKE_MAX_CASES, PARSER_CLIKE_PARSE_SWITCHES, _)


template<int val, typename A>
class CaseP
{
public:
    const A ref;
public:
    CaseP(const parser<A>& a) : ref(a.derived())
    {
    }
    
    template<int val2, typename A2>
    const CLst_2<2, val,A, CLst_1<val2,A2> >
    operator, (const CaseP<val2, A2>& nextcase) const
    {
        return CLst_2<2, val,A, CLst_1<val2,A2> >
                (ref, nextcase.makecase());
    }
    
    /*
    template<typename T>
    CaseP<val,A> operator, (const T& t) const
    {
        fprintf(stderr, "dummy operator,:\n"
            "- this = %s\n"
            "- t    = %s\n",
                typenameof(*this).c_str(),
                typenameof(t).c_str());
        return *this;
    }
    */

    const CLst_1<val,A>
    makecase() const
    {
        return CLst_1<val,A> (ref);
    }
};

template<unsigned N,int val2,class A2,typename T, int val,typename A>
const CLst_2<N+1, val,A,
                 CLst_2<N,val2,A2,T> >
inline operator, (const CLst_2<N,val2,A2,T>& prevlist,
                  const CaseP<val,A>& next)
{
    return
      CLst_2<N+1, val,A,
                 CLst_2<N,val2,A2,T> > (next.ref, prevlist);
}


template<int val,typename A>
CaseP<val,A> case_p(const parser<A>& a) { return CaseP<val,A> (a); }

static struct
{
    template<unsigned N, int val,class A, typename parent>
    caseparser<CLst_2<N,val,A,parent>::depth,
               CLst_2<N,val,A,parent> >
    operator[] (const CLst_2<N,val,A,parent>& a) const
    {
        return a.makeparser();
    }
    
    template<int val,typename A>
    Seq<TKn,A>
    operator[] (const CaseP<val,A>& a) const
    {
        return a.makecase().derived().makeparser();
    }
} switch_p;
